!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ORDER_AXIS(A,N)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: A(N)
integer(kind=iwp) :: i, j
real(kind=wp) :: keep

do I=1,N-1
  do J=I+1,N
    if (A(I) > A(J)) then
      keep = A(I)
      A(I) = A(J)
      A(J) = keep
    end if
  end do
end do

return

end subroutine ORDER_AXIS
